
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>事件总线（Event Bus）知多少（转） / 憋错料</title>

    <meta name="description" content="事件总线（Event Bus）知多少（转） 1. 引言 事件总线这个概念对你来说可能很陌生,但提到观察者(发布-订阅)模式,你也许就很熟悉.事件总线是对发布-订阅模式的一种实现.它是一种集中式事件处理机制,允许不同的组件之间进行彼此通信而又不需要相互依赖,达到一种解耦的目的. 我们来看看事件总线的处理流程: 了解了事件总线的基本概念和处理流程,下面我们就来分析下如何去实现事件总线. 2.回归本质 在动手实现事件总线之前,我们还是要追本溯源,探索一下事件的本质和发布订阅模式的实现机制. 2.1.事件的本质 我们先来探讨一下事件的概念.都是读">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">事件总线（Event Bus）知多少（转）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>1. 引言</h1>
<p>事件总线这个概念对你来说可能很陌生，但提到观察者（发布-订阅）模式，你也许就很熟悉。事件总线是对发布-订阅模式的一种实现。它是一种集中式事件处理机制，允许不同的组件之间进行彼此通信而又不需要相互依赖，达到一种解耦的目的。</p>
<p>我们来看看事件总线的处理流程：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvZ2FrMmxoVnhWNklkbVcxd082MFdXeXhlWUgwMXFhNGVnVnRjR2FMU2EyWmlhRkhFa3FpYndtTWNja0VRRVdOYmRZR2Mzd0JDVHpwZ3lCQnEyYzBSQ0N1Zy82NDA/d3hfZm10PXBuZyZhbXA7dHA9d2VicCZhbXA7d3hmcm9tPTUmYW1wO3d4X2xhenk9MQ==.jpg" data-src="http://mmbiz.qpic.cn/mmbiz_png/gak2lhVxV6IdmW1wO60WWyxeYH01qa4egVtcGaLSa2ZiaFHEkqibwmMcckEQEWNbdYGc3wBCTzpgyBBq2c0RCCug/0?wx_fmt=png"></p>
<p>了解了事件总线的基本概念和处理流程，下面我们就来分析下如何去实现事件总线。</p>
<h1>2.回归本质</h1>
<p>在动手实现事件总线之前，我们还是要追本溯源，探索一下事件的本质和发布订阅模式的实现机制。</p>
<h2>2.1.事件的本质</h2>
<p>我们先来探讨一下事件的概念。都是读过书的，应该都还记得记叙文的六要素：时间、地点、人物、事件（起因、经过、结果）。</p>
<blockquote><p>我们拿注册的案例，来解释一下。<br />用户输入用户名、邮箱、密码后，点击注册，输入无误校验通过后，注册成功并发送邮件给用户，要求用户进行邮箱验证激活。</p></blockquote>
<p>这里面就涉及了两个主要事件：</p>
<ol>
<li>注册事件：起因是用户点击了注册按钮，经过是输入校验，结果是是否注册成功。</li>
<li>发送邮件事件：起因是用户使用邮箱注册成功需要验证邮箱，经过是邮件发送，结果是邮件是否发送成功。</li>
</ol>
<p>其实这六要素也适用于我们程序中事件的处理过程。开发过WinForm程序的都知道，我们在做UI设计的时候，从工具箱拖入一个注册按钮（btnRegister），双击它，VS就会自动帮我们生成如下代码：</p>
<pre><code>void btnRegister_Click(object sender, EventArgs e){ // 事件的处理}</code></pre>
<p>其中<code>object sender</code>指代发出事件的对象，这里也就是button对象；<code>EventArgs e</code>&nbsp;事件参数，可以理解为对事件的描述 ，它们可以统称为<strong>事件源</strong>。其中的代码逻辑，就是对事件的处理。我们可以统称为<strong>事件处理</strong>。</p>
<p>说了这么多，无非是想透过现象看本质：<strong>事件是由事件源和事件处理组成</strong>。</p>
<h2>2.2. 发布订阅模式</h2>
<blockquote><p>定义对象间一种一对多的依赖关系，使得每当一个对象改变状态，则所有依赖于它的对象都会得到通知并被自动更新。 ——发布订阅模式</p></blockquote>
<p>发布订阅模式主要有两个角色：</p>
<ul>
<li>发布方（Publisher）：也称为被观察者，当状态改变时负责通知所有订阅者。</li>
<li>订阅方（Subscriber）：也称为观察者，订阅事件并对接收到的事件进行处理。</li>
</ul>
<p>发布订阅模式有两种实现方式：</p>
<ul>
<li>简单的实现方式：由Publisher维护一个订阅者列表，当状态改变时循环遍历列表通知订阅者。</li>
<li>委托的实现方式：由Publisher定义事件委托，Subscriber实现委托。</li>
</ul>
<p>总的来说，发布订阅模式中有两个关键字，通知和更新。<br />被观察者状态改变通知观察者做出相应更新。<br />解决的是当对象改变时需要通知其他对象做出相应改变的问题。</p>
<p>如果画一个图来表示这个流程的画，图形应该是这样的：</p>
<p><img src="image/gif;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVQImWNgYGBgAAAABQABh6FO1AAAAABJRU5ErkJggg==" data-src="http://mmbiz.qpic.cn/mmbiz_png/gak2lhVxV6IdmW1wO60WWyxeYH01qa4ez4zOjGQJJPZrzEuowVx7Hic5scWqqIFMYcMd9H5xD63O8voa6abXPxw/0?wx_fmt=png"></p>
<h1>3 实现发布订阅模式</h1>
<p>相信通过上面的解释，对事件和发布订阅模式有了一个大概的印象。都说理论要与实践相结合，所以我们还是动动手指敲敲代码比较好。<br />我将以『观察者模式』来钓鱼这个例子为基础，通过重构的方式来完善一个更加通用的发布订阅模式。<br />先上代码：</p>
<pre><code>/// &lt;summary&gt;/// 鱼的品类枚举/// &lt;/summary&gt;public enum FishType
{
 &nbsp; &nbsp;鲫鱼,
 &nbsp; &nbsp;鲤鱼,
 &nbsp; &nbsp;黑鱼,
 &nbsp; &nbsp;青鱼,
 &nbsp; &nbsp;草鱼,
 &nbsp; &nbsp;鲈鱼
}</code></pre>
<p>钓鱼竿的实现：</p>
<pre><code> /// &lt;summary&gt;
 /// &nbsp; &nbsp; 鱼竿（被观察者）
 /// &lt;/summary&gt;
 public class FishingRod
 { &nbsp; &nbsp; public delegate void FishingHandler(FishType type); //声明委托
 &nbsp; &nbsp; public event FishingHandler FishingEvent; //声明事件

 &nbsp; &nbsp; public void ThrowHook(FishingMan man) &nbsp; &nbsp; {
 &nbsp; &nbsp; &nbsp; &nbsp; Console.WriteLine("开始下钩！"); &nbsp; &nbsp;  &nbsp; &nbsp; //用随机数模拟鱼咬钩，若随机数为偶数，则为鱼咬钩
 &nbsp; &nbsp; &nbsp; &nbsp; if (new Random().Next() % 2 == 0)
 &nbsp; &nbsp; &nbsp; &nbsp; { &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; var type = (FishType) new Random().Next(0, 5);
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; Console.WriteLine("铃铛：叮叮叮，鱼儿咬钩了"); &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if (FishingEvent != null)
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; FishingEvent(type);
 &nbsp; &nbsp; &nbsp; &nbsp; }
 &nbsp; &nbsp; }
 }</code></pre>
<p>垂钓者：</p>
<pre><code>/// &lt;summary&gt;/// &nbsp; &nbsp; 垂钓者（观察者）/// &lt;/summary&gt;public class FishingMan{ &nbsp; &nbsp;public FishingMan(string name) &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp;Name = name;
 &nbsp; &nbsp;} &nbsp; &nbsp;public string Name { get; set; } &nbsp; &nbsp;public int FishCount { get; set; } &nbsp; &nbsp;/// &lt;summary&gt;
 &nbsp; &nbsp;/// 垂钓者自然要有鱼竿啊
 &nbsp; &nbsp;/// &lt;/summary&gt;
 &nbsp; &nbsp;public FishingRod FishingRod { get; set; } &nbsp; &nbsp;public void Fishing() &nbsp; &nbsp;{ &nbsp; &nbsp; &nbsp; &nbsp;this.FishingRod.ThrowHook(this);
 &nbsp; &nbsp;} &nbsp; &nbsp;public void Update(FishType type) &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp;FishCount++;
 &nbsp; &nbsp; &nbsp; &nbsp;Console.WriteLine("{0}：钓到一条[{2}]，已经钓到{1}条鱼了！", Name, FishCount, type);
 &nbsp; &nbsp;}
}</code></pre>
<p>场景类也很简单：</p>
<pre><code>//1、初始化鱼竿var fishingRod = new FishingRod();//2、声明垂钓者var jeff = new FishingMan("圣杰");//3.分配鱼竿jeff.FishingRod = fishingRod;//4、注册观察者fishingRod.FishingEvent += jeff.Update;//5、循环钓鱼while (jeff.FishCount &lt; 5)
{
 &nbsp; &nbsp;jeff.Fishing();
 &nbsp; &nbsp;Console.WriteLine("-------------------"); &nbsp; &nbsp;//睡眠5s
 &nbsp; &nbsp;Thread.Sleep(5000);
}</code></pre>
<p>代码很简单，相信你一看就明白。但很显然这个代码实现仅适用于当前这个钓鱼场景，假如有其他场景也想使用这个模式，我们还需要重新定义委托，重新定义事件处理，岂不很累。本着”Don‘t repeat yourself“的原则，我们要对其进行重构。</p>
<p>结合我们对事件本质的探讨，事件是由事件源和事件处理组成。针对我们上面的案例来说，<code>public delegate void FishingHandler(FishType type);</code>这句代码就已经说明了事件源和事件处理。事件源就是<code>FishType type</code>，事件处理自然是注册到<code>FishingHandler</code>上面的委托实例。<br />问题找到了，很显然是我们的事件源和事件处理不够抽象，所以不能通用，下面咱们就来动手改造。</p>
<h2>3.1. 提取事件源</h2>
<p>事件源应该至少包含事件发生的时间和触发事件的对象。<br />我们提取<code>IEventData</code>接口来封装事件源：</p>
<pre><code>/// &lt;summary&gt;/// 定义事件源接口，所有的事件源都要实现该接口/// &lt;/summary&gt;public interface IEventData{ &nbsp; &nbsp;/// &lt;summary&gt;
 &nbsp; &nbsp;/// 事件发生的时间
 &nbsp; &nbsp;/// &lt;/summary&gt;
 &nbsp; &nbsp;DateTime EventTime { get; set; } &nbsp; &nbsp;/// &lt;summary&gt;
 &nbsp; &nbsp;/// 触发事件的对象
 &nbsp; &nbsp;/// &lt;/summary&gt;
 &nbsp; &nbsp;object EventSource { get; set; }
}</code></pre>
<p>自然我们应该给一个默认的实现<code>EventData</code>：</p>
<pre><code>/// &lt;summary&gt;/// 事件源：描述事件信息，用于参数传递/// &lt;/summary&gt;public class EventData : IEventData{ &nbsp; &nbsp;/// &lt;summary&gt;
 &nbsp; &nbsp;/// 事件发生的时间
 &nbsp; &nbsp;/// &lt;/summary&gt;
 &nbsp; &nbsp;public DateTime EventTime { get; set; } &nbsp; &nbsp;/// &lt;summary&gt;
 &nbsp; &nbsp;/// 触发事件的对象
 &nbsp; &nbsp;/// &lt;/summary&gt;
 &nbsp; &nbsp;public Object EventSource { get; set; } &nbsp; &nbsp;public EventData() &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp;EventTime = DateTime.Now;
 &nbsp; &nbsp;}
}</code></pre>
<p>针对Demo，扩展事件源如下：</p>
<pre><code>public class FishingEventData : EventData{ &nbsp; &nbsp;public FishType FishType { get; set; } &nbsp; &nbsp;public FishingMan FisingMan { get; set; }
}</code></pre>
<p>完成后，我们就可以去把在<code>FishingRod</code>声明的委托参数类型改为<code>FishingEventData</code>类型了，即<code>public delegate void FishingHandler(FishingEventData eventData); //声明委托</code>；<br />然后修改<code>FishingMan</code>的<code>Update</code>方法按委托定义的参数类型修改即可，代码我就不放了，大家自行脑补。</p>
<p>到这一步我们就统一了事件源的定义方式。</p>
<h2>3.2.提取事件处理器</h2>
<p>事件源统一了，那事件处理也得加以限制。比如如果随意命名事件处理方法名，那在进行事件注册的时候还要去按照委托定义的参数类型去匹配，岂不麻烦。</p>
<p>我们提取一个<code>IEventHandler</code>接口：</p>
<pre><code> /// &lt;summary&gt;
 /// 定义事件处理器公共接口，所有的事件处理都要实现该接口
 /// &lt;/summary&gt;
 public interface IEventHandler
 {
 }</code></pre>
<p>事件处理要与事件源进行绑定，所以我们再来定义一个泛型接口：</p>
<pre><code> /// &lt;summary&gt;
 /// 泛型事件处理器接口
 /// &lt;/summary&gt;
 /// &lt;typeparam name="TEventData"&gt;&lt;/typeparam&gt;
 public interface IEventHandler&lt;TEventData&gt; : IEventHandler where TEventData : IEventData
 { &nbsp; &nbsp; /// &lt;summary&gt;
 &nbsp; &nbsp; /// 事件处理器实现该方法来处理事件
 &nbsp; &nbsp; /// &lt;/summary&gt;
 &nbsp; &nbsp; /// &lt;param name="eventData"&gt;&lt;/param&gt;
 &nbsp; &nbsp; void HandleEvent(TEventData eventData);
 }</code></pre>
<p>你可能会纳闷，为什么先定义了一个空接口？这里就留给自己思考吧。</p>
<p>至此我们就完成了事件处理的抽象。我们再继续去改造我们的Demo。我们让<code>FishingMan</code>实现<code>IEventHandler</code>接口，然后修改场景类中将<code>fishingRod.FishingEvent += jeff.Update;</code>改为<code>fishingRod.FishingEvent += jeff.HandleEvent;</code>即可。代码改动很简单，同样在此略去。</p>
<p>至此你可能觉得我们完成了对Demo的改造。但事实上呢，我们还要弄清一个问题——如果这个<code>FishingMan</code>订阅的有其他的事件，我们该如何处理？<br />聪颖如你，你立马想到了可以<strong>通过事件源来进行区分处理</strong>。</p>
<pre><code>public class FishingMan : IEventHandler&lt;IEventData&gt;{ &nbsp; &nbsp;//省略其他代码
 &nbsp; &nbsp;public void HandleEvent(IEventData eventData)
 &nbsp; &nbsp;{ &nbsp; &nbsp; &nbsp; &nbsp;if (eventData is FishingEventData)
 &nbsp; &nbsp; &nbsp; &nbsp;{ &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;//do something
 &nbsp; &nbsp; &nbsp; &nbsp;} &nbsp; &nbsp; &nbsp; &nbsp;if(eventData is XxxEventData)
 &nbsp; &nbsp; &nbsp; &nbsp;{ &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;//do something else
 &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp;}
}</code></pre>
<p>至此，这个模式实现到这个地步基本已经可以通用了。</p>
<h1>4. 实现事件总线</h1>
<p>通用的发布订阅模式不是我们的目的，我们的目的是一个集中式的事件处理机制，且各个模块之间相互不产生依赖。那我们如何做到呢？同样我们还是一步一步的进行分析改造。</p>
<h2>4.1.分析问题</h2>
<p>思考一下，每次为了实现这个模式，都要完成以下三步：</p>
<ol>
<li>事件发布方定义事件委托</li>
<li>事件订阅方定义事件处理逻辑</li>
<li>显示的订阅事件</li>
</ol>
<p>虽然只有三步，但这三步已经很繁琐了。而且事件发布方和事件订阅方还存在着依赖（体现在订阅者要显示的进行事件的注册和注销上）。而且当事件过多时，直接在订阅者中实现<code>IEventHandler</code>接口处理多个事件逻辑显然不太合适，违法单一职责原则。这里就暴露了三个问题：</p>
<ol>
<li>如何精简步骤？</li>
<li>如何解除发布方与订阅方的依赖？</li>
<li>如何避免在订阅者中同时处理多个事件逻辑？</li>
</ol>
<p>带着问题思考，我们就会更接近真相。</p>
<p>想要精简步骤，那我们需要寻找共性。共性就是事件的本质，也就是我们针对事件源和事件处理提取出来的两个接口。</p>
<p>想要解除依赖，那就要在发布方和订阅方之间添加一个中介。</p>
<p>想要避免订阅者同时处理过多事件逻辑，那我们就把事件逻辑的处理提取到订阅者外部。</p>
<p>思路有了，下面我们就来实施吧。</p>
<h2>4.2.解决问题</h2>
<p>本着先易后难的思想，我们下面就来解决以上问题。</p>
<h3>4.2.1. 实现IEventHandler</h3>
<p>我们先解决上面的第三个问题：如何避免在订阅者中同时处理多个事件逻辑？</p>
<p>自然是针对不同的事件源<code>IEventData</code>实现不同的<code>IEventHandler</code>。改造后的钓鱼事件处理逻辑如下：</p>
<pre><code>/// &lt;summary&gt;/// 钓鱼事件处理/// &lt;/summary&gt;public class FishingEventHandler : IEventHandler&lt;FishingEventData&gt;
{ &nbsp; &nbsp;public void HandleEvent(FishingEventData eventData)
 &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp;eventData.FishingMan.FishCount++;

 &nbsp; &nbsp; &nbsp; &nbsp;Console.WriteLine("{0}：钓到一条[{2}]，已经钓到{1}条鱼了！",
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;eventData.FishingMan.Name, eventData.FishingMan.FishCount, eventData.FishType);

 &nbsp; &nbsp;}
}</code></pre>
<p>这时我们就可以移除在<code>FishingMan</code>中实现的<code>IEventHandler</code>接口了。<br />然后将事件注册改为<code>fishingRod.FishingEvent += new FishingEventHandler().HandleEvent;</code>即可。</p>
<h3>4.2.2. 统一注册事件</h3>
<p>上一个问题的解决，有助于我们解决第一个问题：如何精简流程？<br />为什么呢，因为我们是根据事件源定义相应的事件处理的。也就是我们之前说的可以根据事件源来区分事件。<br />然后呢？反射，我们可以通过反射来进行事件的统一注册。<br />在<code>FishingRod</code>的构造函数中使用反射，统一注册实现了<code>IEventHandler&lt;FishingEventData&gt;</code>类型的实例方法<code>HandleEvent</code>：</p>
<pre><code>public FishingRod()
{
 &nbsp; &nbsp;Assembly assembly = Assembly.GetExecutingAssembly();

 &nbsp; &nbsp;foreach (var type in assembly.GetTypes())
 &nbsp; &nbsp;{ &nbsp; &nbsp; &nbsp; &nbsp;if (typeof(IEventHandler).IsAssignableFrom(type))//判断当前类型是否实现了IEventHandler接口
 &nbsp; &nbsp; &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;Type handlerInterface = type.GetInterface("IEventHandler`1");//获取该类实现的泛型接口
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;Type eventDataType = handlerInterface.GetGenericArguments()[0]; // 获取泛型接口指定的参数类型

 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;//如果参数类型是FishingEventData，则说明事件源匹配
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;if (eventDataType.Equals(typeof(FishingEventData)))
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;{ &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;//创建实例
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;var handler = Activator.CreateInstance(type) as IEventHandler&lt;FishingEventData&gt;; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;//注册事件
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;FishingEvent += handler.HandleEvent;
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp;}
}</code></pre>
<p>这样，我们就可以移出场景类中的显示注册代码<code>fishingRod.FishingEvent += new FishingEventHandler().HandleEvent;</code>。</p>
<h3>4.2.3. 解除依赖</h3>
<p>如何解除依赖呢？其实答案就在本文的两张图上，仔细对比我们可以很直观的看到，Event Bus就相当于一个介于Publisher和Subscriber中间的桥梁。它隔离了Publlisher和Subscriber之间的直接依赖，接管了所有事件的发布和订阅逻辑，并负责事件的中转。</p>
<p><strong>Event Bus终于要粉墨登场了！！！</strong><br />分析一下，如果EventBus要接管所有事件的发布和订阅，那它则需要有一个容器来记录事件源和事件处理。那又如何触发呢？有了事件源，我们就自然能找到绑定的事件处理逻辑，通过反射触发。代码如下：</p>
<pre><code>/// &lt;summary&gt;/// 事件总线/// &lt;/summary&gt;

public class EventBus{ &nbsp; &nbsp;public static EventBus Default =&gt; new EventBus(); &nbsp; &nbsp;/// &lt;summary&gt;
 &nbsp; &nbsp;/// 定义线程安全集合
 &nbsp; &nbsp;/// &lt;/summary&gt;
 &nbsp; &nbsp;private readonly ConcurrentDictionary&lt;Type, List&lt;Type&gt;&gt; _eventAndHandlerMapping; &nbsp; &nbsp;public EventBus() &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp;_eventAndHandlerMapping = new ConcurrentDictionary&lt;Type, List&lt;Type&gt;&gt;();
 &nbsp; &nbsp; &nbsp; &nbsp;MapEventToHandler();
 &nbsp; &nbsp;} &nbsp; &nbsp;/// &lt;summary&gt;
 &nbsp; &nbsp;///通过反射，将事件源与事件处理绑定
 &nbsp; &nbsp;/// &lt;/summary&gt;
 &nbsp; &nbsp;private void MapEventToHandler() &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp;Assembly assembly = Assembly.GetEntryAssembly(); &nbsp; &nbsp; &nbsp; &nbsp;foreach (var type in assembly.GetTypes())
 &nbsp; &nbsp; &nbsp; &nbsp;{ &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;if (typeof(IEventHandler).IsAssignableFrom(type))//判断当前类型是否实现了IEventHandler接口
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;Type handlerInterface = type.GetInterface("IEventHandler`1");//获取该类实现的泛型接口
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;if (handlerInterface != null)
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;Type eventDataType = handlerInterface.GetGenericArguments()[0]; // 获取泛型接口指定的参数类型

 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;if (_eventAndHandlerMapping.ContainsKey(eventDataType))
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;List&lt;Type&gt; handlerTypes = _eventAndHandlerMapping[eventDataType];
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;handlerTypes.Add(type);
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;_eventAndHandlerMapping[eventDataType] = handlerTypes;
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;} &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;else
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;{ &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;var handlerTypes = new List&lt;Type&gt; { type };
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;_eventAndHandlerMapping[eventDataType] = handlerTypes;
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp;} &nbsp; &nbsp;/// &lt;summary&gt;
 &nbsp; &nbsp;/// 手动绑定事件源与事件处理
 &nbsp; &nbsp;/// &lt;/summary&gt;
 &nbsp; &nbsp;/// &lt;typeparam name="TEventData"&gt;&lt;/typeparam&gt;
 &nbsp; &nbsp;/// &lt;param name="eventHandler"&gt;&lt;/param&gt;
 &nbsp; &nbsp;public void Register&lt;TEventData&gt;(Type eventHandler)
 &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp;List&lt;Type&gt; handlerTypes = _eventAndHandlerMapping[typeof(TEventData)]; &nbsp; &nbsp; &nbsp; &nbsp;if (!handlerTypes.Contains(eventHandler))
 &nbsp; &nbsp; &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;handlerTypes.Add(eventHandler);
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;_eventAndHandlerMapping[typeof(TEventData)] = handlerTypes;
 &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp;} &nbsp; &nbsp;/// &lt;summary&gt;
 &nbsp; &nbsp;/// 手动解除事件源与事件处理的绑定
 &nbsp; &nbsp;/// &lt;/summary&gt;
 &nbsp; &nbsp;/// &lt;typeparam name="TEventData"&gt;&lt;/typeparam&gt;
 &nbsp; &nbsp;/// &lt;param name="eventHandler"&gt;&lt;/param&gt;
 &nbsp; &nbsp;public void UnRegister&lt;TEventData&gt;(Type eventHandler)
 &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp;List&lt;Type&gt; handlerTypes = _eventAndHandlerMapping[typeof(TEventData)]; &nbsp; &nbsp;&nbsp; &nbsp; &nbsp; &nbsp;if (handlerTypes.Contains(eventHandler))
 &nbsp; &nbsp; &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;handlerTypes.Remove(eventHandler);
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;_eventAndHandlerMapping[typeof(TEventData)] = handlerTypes;
 &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp;} &nbsp; &nbsp;/// &lt;summary&gt;
 &nbsp; &nbsp;/// 根据事件源触发绑定的事件处理
 &nbsp; &nbsp;/// &lt;/summary&gt;
 &nbsp; &nbsp;/// &lt;typeparam name="TEventData"&gt;&lt;/typeparam&gt;
 &nbsp; &nbsp;/// &lt;param name="eventData"&gt;&lt;/param&gt;
 &nbsp; &nbsp;public void Trigger&lt;TEventData&gt;(TEventData eventData)&nbsp; &nbsp; &nbsp; &nbsp; where TEventData : IEventData
 &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp;List&lt;Type&gt; handlers = _eventAndHandlerMapping[eventData.GetType()]; &nbsp; &nbsp; &nbsp; &nbsp;if (handlers != null &amp;&amp; handlers.Count &gt; 0)
 &nbsp; &nbsp; &nbsp; &nbsp;{ &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;foreach (var handler in handlers)
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;{
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;MethodInfo methodInfo = handler.GetMethod("HandleEvent"); &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;if (methodInfo != null)
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;{ &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;object obj = Activator.CreateInstance(handler);
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;methodInfo.Invoke(obj, new object[] { eventData });
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp;}
}</code></pre>
<p>事件总线主要定义三个方法，注册、取消注册、事件触发。还有一点就是我们在构造函数中通过反射去进行事件源和事件处理的绑定。<br />代码注释已经很清楚了，这里就不过多解释了。</p>
<p>下面我们就来修改Demo，修改<code>FishingRod</code>的事件触发：</p>
<pre><code>/// &lt;summary&gt;/// 下钩/// &lt;/summary&gt;public void ThrowHook(FishingMan man){
 &nbsp; &nbsp;Console.WriteLine("开始下钩！"); &nbsp; &nbsp;//用随机数模拟鱼咬钩，若随机数为偶数，则为鱼咬钩
 &nbsp; &nbsp;if (new Random().Next() % 2 == 0)
 &nbsp; &nbsp;{ &nbsp; &nbsp; &nbsp; &nbsp;var a = new Random(10).Next(); &nbsp; &nbsp; &nbsp; &nbsp;var type = (FishType)new Random().Next(0, 5);
 &nbsp; &nbsp; &nbsp; &nbsp;Console.WriteLine("铃铛：叮叮叮，鱼儿咬钩了"); &nbsp; &nbsp; &nbsp;&nbsp; &nbsp;if (FishingEvent != null)
 &nbsp; &nbsp; &nbsp; &nbsp;{ &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;var eventData = new FishingEventData() { FishType = type, FishingMan = man }; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;//FishingEvent(eventData);//不再需要通过事件委托触发
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;EventBus.Default.Trigger&lt;FishingEventData&gt;(eventData);//直接通过事件总线触发即可
 &nbsp; &nbsp; &nbsp; &nbsp;}
 &nbsp; &nbsp;}
}</code></pre>
<p>至此，事件总线的雏形已经形成！</p>
<h1>5.事件总线的总结</h1>
<p>通过上面一步一步的分析和实践，发现事件总线也不是什么高深的概念，只要我们自己善于思考，勤于动手，也能实现自己的事件总线。<br />根据我们的实现，大概总结出以下几条：</p>
<ol>
<li>事件总线维护一个事件源与事件处理的映射字典；</li>
<li>通过单例模式，确保事件总线的唯一入口；</li>
<li>利用反射完成事件源与事件处理的初始化绑定；</li>
<li>提供统一的事件注册、取消注册和触发接口。</li>
</ol>
<p>最后，以上事件总线的实现只是一个雏形，还有很多潜在的问题。有兴趣的不妨思考完善一下，我也会继续更新完善，尽情期待！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 01:31:41 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/alt/" title="alt">alt</a>, <a href="https://www.biecuoliao.com/tag/%e6%89%8b%e5%8a%a8/" title="手动">手动</a>, <a href="https://www.biecuoliao.com/tag/%e6%b3%a8%e9%87%8a/" title="注释">注释</a>, <a href="https://www.biecuoliao.com/tag/%e5%85%b3%e7%b3%bb/" title="关系">关系</a>, <a href="https://www.biecuoliao.com/tag/%e6%9c%89%e5%8a%a9%e4%ba%8e/" title="有助于">有助于</a>, <a href="https://www.biecuoliao.com/tag/who/" title="who">who</a>, <a href="https://www.biecuoliao.com/tag/rem/" title="rem">rem</a>, <a href="https://www.biecuoliao.com/tag/gas/" title="gas">gas</a>, <a href="https://www.biecuoliao.com/tag/%e9%9b%86%e4%b8%ad%e5%bc%8f/" title="集中式">集中式</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>事件总线（Event Bus）知多少（转）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QWJgo0.html" rel="bookmark">事件总线（Event Bus）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				事件总线(Event Bus)知多少 源码路径:Github-EventBus简书同步链接 1. 引言 事件总线这个概念对你来说可能很陌生,但提到观察者(发布-订阅)模式,你也许就很熟悉.事件总线是对发布-订阅模式的一种实现.它是一种集中式事件处理机制,允许不同的组件之间进行彼此通信而又不需要相互依赖,达到一种解耦的目的. 我们来看看事件总线的处理流程: 了解了事件总线的基本概念和处理流程,下面我们就来分析下如何去实现事件总线. 2.回归本质 在动手实现事件总线之前,我们还是要追本溯源,探索一下			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MB2Z2YM.html" rel="bookmark">事件总线bus解决兄弟组件之间的传值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文引用https://www.dazhuanlan.com/2019/08/25/5d625951eff92/ 事件总线bus解决兄弟组件之间的传值 实际运用: 封装一个Bus.js 123 import Vue from 'vue'const Bus = new Vue()export default Bus 在组件调用时引入 组件一: 1234567891011121314 import Bus from './Bus' export default { data() { return {			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4J2zDb4.html" rel="bookmark">EventBus 事件总线 原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原理 一句话描述:register会把当前类中匹配的方法,存入一个map,而post会根据实参去map查找进行反射调用 撇开专业术语,其实EventBus就是在内部[存储]了一堆onEvent开头的方法,然后post的时候,根据post传入的[参数],去找到匹配的方法,[反射]调用之. 另外,它内部使用了[Map]进行存储,[键就是参数的Class类型].知道是这个类型,那么你觉得根据post传入的参数进行查找还是个事么? 其实不用发布者,订阅者,事件,总线这几个词或许更好理解,以后大家问了Ev			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/yMXZ183.html" rel="bookmark">事件总线框架---Otto</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们假设这样一种业务场景,现在在做一款及时聊天应用,我们在聊天页面进行收发信息,同时也要实时更新前一页面的聊天记录,这时我们该如何去实现?说说我以前的实现策略,我使用的是广播接收器BroadCastReceiver,在接收和发送消息的时候就不停去发送广播,然后在需要实时更新的地方进行接收更新.实现的思想比较简单,也不存在代码上的耦合问题,但是有个弊端.弊端就是需要去在很多地方实现BroadCastRecevier,代码虽不算冗余,但比较多,看起来很是不爽. 今天为大家介绍的Otto,就能彻底解决			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/pMP6V63.html" rel="bookmark">Guava&colon; 事件总线EventBus</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				EventBus 直译过来就是事件总线,它使用发布订阅模式支持组件之间的通信,不需要显式地注册回调,比观察者模式更灵活,可用于替换Java中传统的事件监听模式,EventBus的作用就是解耦,它不是通用的发布订阅系统,也不能用于进程间通信.可用于Android的EventBus库主要有这几个:Google出品的Guava,Guava是一个庞大的库,EventBus 只是它附带的一个小功能,因此实际项目中使用并不多.用的最多的是greenrobot/EventBus,这个库的优点是接口简洁,集成方			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLDqAvM.html" rel="bookmark">Android事件总线</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android事件总线还能怎么玩? 顾名思义,AndroidEventBus ( github链接 ,关于我为什么要写这个库请参考&lt;AndroidEventBus ( 事件总线 ) 的设计与实现&gt;)是一个Android平台的事件总线框架,它简化了Activity.Fragment.Service等组件之间的交互,很大程度上降低了它们之间的耦合,使我们的代码更加简洁,耦合性更低,提升了我们的代码质量.但它能做的却不仅限于这些.经过定制,它能完成很多有意思的功能,那么究竟该怎么做呢?就让我们一起往			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBRarZM.html" rel="bookmark">android事件总线&lpar;eventbus&rpar;开源库发布</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 AndroidEventBus 如果你不知道事件总线是什么,那么没有关系,下面我们先来看这么一个场景: 你是否在开发的过程中遇到过想在Activity-B中回调Activity-A中的某个函数,但Activity又不能手动创建对象来设置一个Listener什么的? 你是否想在某个Service中想更新Activity或者Fragment中的界面? 等等之类的组件之间的交互问题-- 一经思考,你会发现Android中的Activity, Fragment, Service之间的交互是比较麻烦的,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e5a550.html" rel="bookmark">EventBus 事件总线 简介 案例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介 地址:https://github.com/greenrobot/EventBus EventBus是一款针对Android优化的发布/订阅事件总线.主要功能是替代Intent,Handler,BroadCast在Fragment,Activity,Service,线程之间传递消息. 优点是开销小,代码更优雅,以及将发送者和接收者解耦. 包含4个成分:发布者,订阅者,事件,总线. 这四者的关系:订阅者订阅事件到总线,发送者发布事件:订阅者可以订阅多个事件,发送者可以发布任何事件,发布者同时			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzQJPJ4.html" rel="bookmark">EventBus事件总线分发库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文围绕以下六个部分展开: 一.事件总线管理 二.EventBus 三.EventBus与BroadcastReceiver的区别 案例一 案例二:一处点击发送数据,另一处或多处注册点可以及时获取更新传输过来的数据 案例三:Activity和Service之间互相发布与接收事件 一.事件总线管理 将事件放入队列里,用于管理和分发. (1)保证应用的各个部分之间高效的通信及数据.事件分发. (2)模块间解耦:通过事件的分发,可以让各个模块间关联程序变小. 当在开发一些庞大的的项目时,模块比较多,这			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/N4peQgM.html" rel="bookmark" class="title">saltstack安装配置使用</a>
					<div>
						背景:puppet 用ruby开发,saltstack用python语言开发的包 环境: 修改hostname和hosts文件, 关闭selinux,清空iptables 172.16.115.157 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0KwdK0.html" rel="bookmark" class="title">python-MySQLdb接口程序安装</a>
					<div>
						centos 7,python2.7 安装python-MySQLdb,因是最小化安装,安装过程中需要依赖其他的工具或包 [[email protected] ~]# pipinstall mysql ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j4Nk7ZM.html" rel="bookmark" class="title">函数声明</a>
					<div>
						语法 function name([param,[, param,[..., param]]]) { [statements] } name 函数名 param 传递非函数的参数名,参数个数最多255 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDRL1Y3.html" rel="bookmark" class="title">Visual Studio 2005 自带单元测试</a>
					<div>
						一 单元测试简介 单元测试是代码正确性验证的最重要的工具,也是系统测试当中最重要的环节.也是唯一需要编写代码才能进行测试的一种测试方法.在标准的开发过程中,单元测试的代码与实际程序的代码具有同等的重要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8VZy3.html" rel="bookmark" class="title">VC&plus;&plus;6&period;0网络编程Socket编程（转）</a>
					<div>
						从csdn上下载的该软件的教程: 作为一个初学者,深感Socket编程入门的困难,但当把一些问题弄懂之后,回过头来看以前遇到的一些问题,才发现 Socket编程其实并没有那么复杂.接下来我就把我遇到的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8xzO3.html" rel="bookmark" class="title">蓝懿 iOS 复习内容 数组 等</a>
					<div>
						又逢周六,我感觉最近这3天学习的东西挺多的,但是今天来上自习的人刚觉刚刚一半左右,也许是由于这两周大家都没有休息时间的原因吧!但时我自己对这几天所学的东西也不是特别把握,今天看了一天也没能完全系统性的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OajKGM.html" rel="bookmark" class="title">极盗者-带你领略八项极限挑战（含代码）</a>
					<div>
						&lt;!-- HTML代码片段中请勿添加&lt;body&gt;标签 //--&gt;&lt;div id=&quot;container&quot;&gt; &lt;/div&gt; &lt;!- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41gP2G0.html" rel="bookmark" class="title">上拉刷新，下拉加载</a>
					<div>
						#import &quot;AppDelegate.h&quot; #import &quot;MyTableViewController.h&quot; @interfaceAppDelegate  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0enjwE3.html" rel="bookmark" class="title">基于C&num;&period;net&comma;sql server学生成绩管理系统---Shinepans</a>
					<div>
						未完待续,代码稍后上传.............2014-9-5					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38L2523.html" rel="bookmark" class="title">TStringList  TMemo Text与Add赋值的区别</a>
					<div>
						list := TStringList.Create;  list.Text:= str:  list.Count; list.Clear;  list.Add(str);  list.Count;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RGbkP3.html" rel="bookmark" class="title">图的遍历（BFS、DFS的邻接矩阵和邻接表实现）</a>
					<div>
						当年老师给我们讲这里的时候,讲的真是云里雾里的. .其实画个图就很容易理解的事情,为什么扯那么远 我觉得 DFS其实就是树的先序遍历的强化版本 BFS是层序遍历的强化 只不过 图的实现方式比较多元化  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41Bg1XM.html" rel="bookmark" class="title">hdu 1671 Phone List &lpar;Trie树&rpar;</a>
					<div>
						简单的字典树应用,在建树的时候判断就行了. 需要注意的语法: 在使用malloc和free来处理动态内存的时候,仅仅是释放了这个对象所占的内存,而不会调用这个对象的析构函数:使用new和delete就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgNyX84.html" rel="bookmark" class="title">2014第18周日</a>
					<div>
						今天大部分时间静下来编码,处理了另外两位同事敦促的接口问题,而没有真心按照自己的规划解决我认为的项目中可能会存在的各种问题,并明确出优先级来解决掉.总是找各种借口和一些琐事来填满正常的上班时间,然后不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDvxvp3.html" rel="bookmark" class="title">css基础样式总结</a>
					<div>
						颜色和单位的使用 颜色 用颜色的名字表示颜色,比如:red 用16进制表示演示 比如:#FF0000 用rgb数值表示颜色,rgb(红,绿,蓝),每个值都在0-255之间一般都用16进制表示颜色 单位 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NqGNw3.html" rel="bookmark" class="title">Discovering the Computer Science Behind Postgres Indexes</a>
					<div>
						This is the last in a series of Postgres posts that Pat Shaughnessy wrote based on his presentation  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOAZ90.html" rel="bookmark" class="title">golang 下 mongodb 与 postgresql 插入速度的测试</a>
					<div>
						近期看了篇文章,说是postgresql也支持nosql,定义了专属的jsonb数据类型,而且速度比mongodb还快,今天验证了下,同样的数据,postgre的插入速度只是mongo 的三分一不到. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODGA94.html" rel="bookmark" class="title">&lbrack;问题2014A02&rsqb; 解答二（求和法&plus;拆分法，由张诚纯同学提供）</a>
					<div>
						[问题2014A02] 解答二(求和法+拆分法,由张诚纯同学提供) 将行列式 \(D_n\) 的第二列,\(\cdots\),第 \(n\) 列全部加到第一列,可得 \[ D_n=\begin{vma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49LVlg3.html" rel="bookmark" class="title">28、java文件上传下载、邮件收发</a>
					<div>
						文件上传下载 前台: 1. 提交方式:post 2. 表单中有文件上传的表单项: &lt;input type=&quot;file&quot; /&gt; 3. 指定表单类型: 默认类型:encty ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AEoBg4.html" rel="bookmark" class="title">ExtJS教程（2）--- Javascript类和对象基础知识</a>
					<div>
						Javascript中的类其实就是一个function 如下面定义一个Person类 //定义一个类 function Person(){ this.name = 'jaune'; this.age  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZQabG0.html" rel="bookmark" class="title">教你微信图文消息快速添加视频的方法</a>
					<div>
						最近国防部发布征兵宣传片:军营版&lt;小苹果&gt;的视频很火,好东西不能独享,决定让公众号粉丝也happy一下,怎样在微信图文消息快速添加视频呢?瞧下xmyanke摸索的方法吧. 首先,到腾讯视频 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
